glibmm: Gio::PollableInputStream Class Reference

glibmm 2.72.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::PollableInputStream Class Reference

PollableInputStream - Interface for pollable input streams. More...

`#include <giomm/pollableinputstream.h>`

Inheritance diagram for Gio::PollableInputStream:
[legend]

## Public Member Functions
| PollableInputStream (PollableInputStream && src) noexcept
PollableInputStream & | operator= (PollableInputStream && src) noexcept
| ~PollableInputStream () noexcept override
GPollableInputStream * | gobj ()
| Provides access to the underlying C GObject. More...
const GPollableInputStream * | gobj () const
| Provides access to the underlying C GObject. More...
bool | can_poll () const
| Checks if stream is actually pollable. More...
bool | is_readable () const
| Checks if stream can be read. More...
gssize | read_nonblocking (void * buffer, gsize count, const Glib::RefPtr< Cancellable > & cancellable)
| Attempts to read up to count bytes from stream into buffer, as with g_input_stream_read(). More...
gssize | read_nonblocking (void * buffer, gsize count)
| A read_nonblocking() convenience overload. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject * castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject * | gobj ()
| Provides access to the underlying C GObject. More...
const GObject * | gobj () const
| Provides access to the underlying C GObject. More...
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| PollableInputStream ()
| You should derive from this class to use it. More...
virtual bool | can_poll_vfunc () const
virtual bool | is_readable_vfunc () const
virtual gssize | read_nonblocking_vfunc (void * buffer, gsize count)
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::PollableInputStream > | wrap (GPollableInputStream * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

PollableInputStream - Interface for pollable input streams.

PollableInputStream is implemented by InputStreams that can be polled for readiness to read. This can be used when interfacing with a non-GIO API that expects UNIX-file-descriptor-style asynchronous I/O rather than GIO-style.

Since glibmm 2.34:

## Constructor & Destructor Documentation

## ◆ PollableInputStream() [1/2]

Gio::PollableInputStream::PollableInputStream | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ PollableInputStream() [2/2]

Gio::PollableInputStream::PollableInputStream | ( | PollableInputStream && | src | ) |
| noexcept

## ◆ ~PollableInputStream()

Gio::PollableInputStream::~PollableInputStream | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gio::PollableInputStream::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ can_poll()

bool Gio::PollableInputStream::can_poll | ( |  | ) | const

Checks if stream is actually pollable.

Some classes may implement PollableInputStream but have only certain instances of that class be pollable. If this method returns `false`, then the behavior of other PollableInputStream methods is undefined.

For any given stream, the value returned by this method is constant; a stream cannot switch from pollable to non-pollable or vice versa.

Since glibmm 2.28:

Returns
  `true` if stream is pollable, `false` if not.

## ◆ can_poll_vfunc()

virtual bool Gio::PollableInputStream::can_poll_vfunc | ( |  | ) | const
| protectedvirtual

## ◆ get_type()

static GType Gio::PollableInputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GPollableInputStream * Gio::PollableInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GPollableInputStream * Gio::PollableInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ is_readable()

bool Gio::PollableInputStream::is_readable | ( |  | ) | const

Checks if stream can be read.

Note that some stream types may not be able to implement this 100% reliably, and it is possible that a call to g_input_stream_read() after this returns `true` would still block. To guarantee non-blocking behavior, you should always use g_pollable_input_stream_read_nonblocking(), which will return a Gio::Error::WOULD_BLOCK error rather than blocking.

Since glibmm 2.28:

Returns
  `true` if stream is readable, `false` if not. If an error has occurred on stream, this will result in g_pollable_input_stream_is_readable() returning `true`, and the next attempt to read will return the error.

## ◆ is_readable_vfunc()

virtual bool Gio::PollableInputStream::is_readable_vfunc | ( |  | ) | const
| protectedvirtual

## ◆ operator=()

PollableInputStream & Gio::PollableInputStream::operator= | ( | PollableInputStream && | src | ) |
| noexcept

## ◆ read_nonblocking() [1/2]

gssize Gio::PollableInputStream::read_nonblocking | ( | void * | buffer,
|  | gsize | count
| ) |  |

A read_nonblocking() convenience overload.

## ◆ read_nonblocking() [2/2]

gssize Gio::PollableInputStream::read_nonblocking | ( | void * | buffer,
|  | gsize | count,
|  | const Glib::RefPtr< Cancellable > & | cancellable
| ) |  |

Attempts to read up to count bytes from stream into buffer, as with g_input_stream_read().

If stream is not currently readable, this will immediately return Gio::Error::WOULD_BLOCK, and you can use g_pollable_input_stream_create_source() to create a Source that will be triggered when stream is readable.

Note that since this method never blocks, you cannot actually use cancellable to cancel it. However, it will return an error if cancellable has already been cancelled when you call, which may happen if you call this method after a source triggers due to having been cancelled.

Virtual: read_nonblocking

Parameters

  buffer | A buffer to read data into (which should be at least count bytes long).
  count | The number of bytes you want to read.
  cancellable | A Cancellable, or `nullptr`.

Returns
  The number of bytes read, or -1 on error (including Gio::Error::WOULD_BLOCK).

Exceptions

  Glib::Error |

## ◆ read_nonblocking_vfunc()

virtual gssize Gio::PollableInputStream::read_nonblocking_vfunc | ( | void * | buffer,
|  | gsize | count
| ) |  |
| protectedvirtual

Exceptions

  Glib::Error. |

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::PollableInputStream > wrap | ( | GPollableInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.